-- set name and namespace
addonname, PAR = ...

-- shortcut
local CPB = C_PetBattles

-- lazy, easy condition evaluation functions
local function Any(v, t) for i = 1, #t do if (v == t[i]) then return true end end return false end
local function NotAny(v, t) for i = 1, #t do if (v == t[i]) then return false end end return true end

-- auras that cause misses
PAR.MissAuras = {
	260, -- 259 Invisibility, not related but keeping it here just in case
	340, -- 159 Burrow
	341, -- 170 Lift-Off, 588 Devastate, and 612 Proto-Strike
	737, -- 407 Meteor Strike
	830, -- 564 Dive
	839, -- 761 Heroic Leap
	852, -- 645 Launch
}

-- abilities that I am willing to analyze for hit/miss data

--[[
EXCEPTIONS to data recording
-- RETURN if it doesn't have a Hit Chance in the tooltip!
-- RETURN if the enemy is using a "Dive" type attack
-- RETURN if the ability has secondary effects with a different chance to hit

AccuracyAuras = {
	187 = 25, -- 188 Accuracy
	251 = 50, -- 252 Uncanny Luck and 757 Lucky Dance
	425 = 100, -- 426 Focus
	462 = -50, -- 463 Flash and 913 Spectral Spine
	526 = -25, -- 527 Stench
	721 = -20, -- 575 Slippery Ice
	790 = -25, -- 791 Stimpack
	841 = -25, -- 197 Adrenal Glands
	963 = -25 -- 964 Autumn Breeze
}]]--
	
--[[local PAR_DT = _G["PAR_DT"] or CreateFrame("Frame","PAR_DT",UIParent,"SharedPetBattleAbilityTooltipTemplate")
		PAR_PBAI.petOwner = petOwner
		PAR_PBAI.petIndex = petIndex
		PAR_PBAI.abilityID = nil
		PAR_PBAI.abilityIndex = ???
		SharedPetBattleAbilityTooltip_SetAbility(PAR_DT, PAR_PBAI)]]--


		-- how to get a unitState (part of accuracy)
		-- how to get a padState (part of accuracy) - apparently PET_BATTLE_PAD_INDEX = 0 here
		-- how to get a weatherState (part of accuracy) - LE_BATTLE_PET_WEATHER and PET_BATTLE_PAD_INDEX are both = 0 here
		-- 257 is Darkness
		-- 454 is Sandstorm
		--CPB.GetStateValue(petOwner, petIndex, stateID)

		--[[if (not strmatch(message, "applied")) and (not strmatch(message, "dodged")) then
			elseif strmatch(message, "missed") then
				--WasteTime.Accuracy.Miss = floor(WasteTime.Accuracy.Miss + 1 + 0.5)
				--WasteTime.Accuracy.Total = floor(WasteTime.Accuracy.Total + 1 + 0.5)
			--elseif strmatch(message, "(Critical)") then
			else
				--WasteTime.Accuracy.Hit = floor(WasteTime.Accuracy.Hit + 1 + 0.5)
				--WasteTime.Accuracy.Total = floor(WasteTime.Accuracy.Total + 1 + 0.5)
			end
		end]]--
--print("WastingTime: Crush dodged. " .. string.format("Hits: %u (%4.1f%%), Crits: %u (%4.1f%%), Misses: %u (%4.1f%%), Dodge: %u (%4.1f%%), Total: %u.", WasteTime.Accuracy.Hit, (WasteTime.Accuracy.Hit / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Crit, (WasteTime.Accuracy.Crit / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Miss, (WasteTime.Accuracy.Miss / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Dodge, (WasteTime.Accuracy.Dodge / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Total))
--print("WastingTime: Crush missed. " .. string.format("Hits: %u (%4.1f%%), Crits: %u (%4.1f%%), Misses: %u (%4.1f%%), Dodge: %u (%4.1f%%), Total: %u.", WasteTime.Accuracy.Hit, (WasteTime.Accuracy.Hit / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Crit, (WasteTime.Accuracy.Crit / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Miss, (WasteTime.Accuracy.Miss / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Dodge, (WasteTime.Accuracy.Dodge / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Total))
--print("WastingTime: Crush crit. " .. string.format("Hits: %u1 (%4.1f%%), Crits: %u (%4.1f%%), Misses: %u (%4.1f%%), Dodge: %u (%4.1f%%), Total: %u.", WasteTime.Accuracy.Hit, (WasteTime.Accuracy.Hit / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Crit, (WasteTime.Accuracy.Crit / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Miss, (WasteTime.Accuracy.Miss / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Dodge, (WasteTime.Accuracy.Dodge / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Total))
--print("WastingTime: Crush hit. " .. string.format("Hits: %u (%4.1f%%), Crits: %u (%4.1f%%), Misses: %u (%4.1f%%), Dodge: %u (%4.1f%%), Total: %u.", WasteTime.Accuracy.Hit, (WasteTime.Accuracy.Hit / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Crit, (WasteTime.Accuracy.Crit / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Miss, (WasteTime.Accuracy.Miss / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Dodge, (WasteTime.Accuracy.Dodge / WasteTime.Accuracy.Total * 100), WasteTime.Accuracy.Total))